Index: XIOS/dev/branch_yushan/src/test/test_complete.f90
===================================================================
--- XIOS/dev/branch_yushan/src/test/test_complete.f90	(revision 1109)
+++ XIOS/dev/branch_yushan/src/test/test_complete.f90	(revision 1115)
@@ -236,6 +236,6 @@
 !####################################################################################
 
-    DO ts=1,24*10
-    !DO ts=1,24
+    !DO ts=1,24*10
+    DO ts=1,24
 
       CALL xios_get_handle("atmosphere",ctx_hdl)
Index: XIOS/dev/branch_yushan/src/test/test_complete_omp.f90
===================================================================
--- XIOS/dev/branch_yushan/src/test/test_complete_omp.f90	(revision 1109)
+++ XIOS/dev/branch_yushan/src/test/test_complete_omp.f90	(revision 1115)
@@ -181,50 +181,50 @@
 !!! Initialisation des coordonnes globales et locales pour la grille indexee (1 point sur 2)
 
-    nb_pt=ni*nj/2
-    ALLOCATE(kindex(nb_pt),field_A_srf(nb_pt,llm))
-    DO i=1,nb_pt
-      kindex(i)=2*i-1
-    ENDDO
-    field_A_srf(1:nb_pt,:)=RESHAPE(field_A_glo(ibegin+1:iend+1:2,jbegin+1:jend+1,:),(/ nb_pt,llm /))
-
-  CALL xios_context_initialize("surface",comm)
-
-  CALL xios_get_handle("surface",ctx_hdl)
-  CALL xios_set_current_context(ctx_hdl)
-
-  CALL xios_define_calendar(type="Gregorian", &
-                            start_date=xios_date(2000, 01, 01, 00, 00, 00), &
-                            time_origin=xios_date(1999, 01, 01, 15, 00, 00))
-
-  CALL xios_set_axis_attr("axis_srf",n_glo=llm ,value=lval)
-  CALL xios_set_domain_attr("domain_srf",ni_glo=ni_glo, nj_glo=nj_glo, ibegin=ibegin, ni=ni,jbegin=jbegin,nj=nj, type='curvilinear')
-  CALL xios_set_domain_attr("domain_srf",data_dim=1, data_ibegin=0, data_ni=nb_pt)
-  CALL xios_set_domain_attr("domain_srf",data_i_index=kindex)
-  CALL xios_set_domain_attr("domain_srf",lonvalue_2D=lon,latvalue_2D=lat)
+!    nb_pt=ni*nj/2
+!    ALLOCATE(kindex(nb_pt),field_A_srf(nb_pt,llm))
+!    DO i=1,nb_pt
+!      kindex(i)=2*i-1
+!    ENDDO
+!    field_A_srf(1:nb_pt,:)=RESHAPE(field_A_glo(ibegin+1:iend+1:2,jbegin+1:jend+1,:),(/ nb_pt,llm /))
+
+!  CALL xios_context_initialize("surface",comm)
+
+!  CALL xios_get_handle("surface",ctx_hdl)
+!  CALL xios_set_current_context(ctx_hdl)
+
+!  CALL xios_define_calendar(type="Gregorian", &
+!                            start_date=xios_date(2000, 01, 01, 00, 00, 00), &
+!                            time_origin=xios_date(1999, 01, 01, 15, 00, 00))
+
+!  CALL xios_set_axis_attr("axis_srf",n_glo=llm ,value=lval)
+!  CALL xios_set_domain_attr("domain_srf",ni_glo=ni_glo, nj_glo=nj_glo, ibegin=ibegin, ni=ni,jbegin=jbegin,nj=nj, type='curvilinear')
+!  CALL xios_set_domain_attr("domain_srf",data_dim=1, data_ibegin=0, data_ni=nb_pt)
+!  CALL xios_set_domain_attr("domain_srf",data_i_index=kindex)
+!  CALL xios_set_domain_attr("domain_srf",lonvalue_2D=lon,latvalue_2D=lat)
 
 !!! Cration d un nouveau champ
 
-  CALL xios_get_handle("field_definition",fieldgroup_hdl)
-  CALL xios_add_child(fieldgroup_hdl,field_hdl,"field_B_srf")
+ ! CALL xios_get_handle("field_definition",fieldgroup_hdl)
+!  CALL xios_add_child(fieldgroup_hdl,field_hdl,"field_B_srf")
 
 !!! Heritage des attributs d un autre champ
 
-  CALL xios_set_attr(field_hdl,field_ref="field_A_srf",name="field_B_srf")
+!  CALL xios_set_attr(field_hdl,field_ref="field_A_srf",name="field_B_srf")
 
 !!! Affectation de ce nouveau champ au fichier avec un nouveau nom
 
-  CALL xios_get_handle("output_surface",file_hdl)
-  CALL xios_add_child(file_hdl,field_hdl)
-  CALL xios_set_attr(field_hdl,field_ref="field_B_srf",name="field_C_srf")
+!  CALL xios_get_handle("output_surface",file_hdl)
+!  CALL xios_add_child(file_hdl,field_hdl)
+!  CALL xios_set_attr(field_hdl,field_ref="field_B_srf",name="field_C_srf")
 
 !!! Definition du timestep
 
-  dtime%second=1800
-  CALL xios_set_timestep(timestep=dtime)
+!  dtime%second=1800
+!  CALL xios_set_timestep(timestep=dtime)
 
 !!! Recupration des valeurs des longitudes et de taille des domaines locaux (pour test de fonctionnalit)
 
-  ni=0 ; lonvalue(:,:)=0
-  CALL xios_get_domain_attr("domain_srf",ni=ni,lonvalue_2D=lonvalue)
+!  ni=0 ; lonvalue(:,:)=0
+!  CALL xios_get_domain_attr("domain_srf",ni=ni,lonvalue_2D=lonvalue)
 
   !PRINT *,"ni",ni
@@ -233,7 +233,7 @@
 !!! Fin de la definition du contexte SRF
 
-  CALL xios_close_context_definition()
-
-  print *, "xios_close_context_definition(surface)" 
+!  CALL xios_close_context_definition()
+
+!  print *, "xios_close_context_definition(surface)" 
 
 
@@ -242,9 +242,9 @@
 !####################################################################################
 
-    DO ts=1,24*10
-    !DO ts=1,24
-
-      CALL xios_get_handle("atmosphere",ctx_hdl)
-      CALL xios_set_current_context(ctx_hdl)
+    !DO ts=1,24*10
+    DO ts=1,24
+
+      !CALL xios_get_handle("atmosphere",ctx_hdl)
+      !CALL xios_set_current_context(ctx_hdl)
 
 !!! Mise a jour du pas de temps
@@ -258,14 +258,14 @@
 !!! On change de contexte
 
-      CALL xios_get_handle("surface",ctx_hdl)
-      CALL xios_set_current_context(ctx_hdl)
+!      CALL xios_get_handle("surface",ctx_hdl)
+!      CALL xios_set_current_context(ctx_hdl)
 
 !!! Mise a jour du pas de temps
 
-      CALL xios_update_calendar(ts)
+ !     CALL xios_update_calendar(ts)
 
 !!! On donne la valeur du champ srf
 
-      CALL xios_send_field("field_A_srf",field_A_srf)
+ !     CALL xios_send_field("field_A_srf",field_A_srf)
 
       CALL wait_us(5000) ;
@@ -283,15 +283,15 @@
 
 
-    CALL xios_get_handle("surface",ctx_hdl) 
-
-    CALL xios_set_current_context(ctx_hdl)
-
-    CALL xios_context_finalize()
-
-    print *, "xios_context_finalize(surface)" 
-
-     CALL xios_get_handle("atmosphere",ctx_hdl)
-
-     CALL xios_set_current_context(ctx_hdl)
+!    CALL xios_get_handle("surface",ctx_hdl) 
+
+!    CALL xios_set_current_context(ctx_hdl)
+
+!    CALL xios_context_finalize()
+
+!    print *, "xios_context_finalize(surface)" 
+
+     !CALL xios_get_handle("atmosphere",ctx_hdl)
+
+     !CALL xios_set_current_context(ctx_hdl)
 
      CALL xios_context_finalize()
@@ -308,5 +308,5 @@
 
     DEALLOCATE(lon, lat, field_A_atm, lonvalue)
-    DEALLOCATE(kindex, field_A_srf)
+!    DEALLOCATE(kindex, field_A_srf)
 
      print *, "Client : xios_finalize "
Index: XIOS/dev/branch_yushan/src/test/test_omp.f90
===================================================================
--- XIOS/dev/branch_yushan/src/test/test_omp.f90	(revision 1109)
+++ XIOS/dev/branch_yushan/src/test/test_omp.f90	(revision 1115)
@@ -45,5 +45,5 @@
     CALL MPI_COMM_RANK(MPI_COMM_WORLD,rank,ierr)
     CALL MPI_COMM_SIZE(MPI_COMM_WORLD,size,ierr)
-    if(rank < size-1) then
+    if(rank < size-2) then
 
     !$omp parallel default(private)